﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Test2_KolinichenkoES_33P
{
    /// <summary>
    /// Класс Животных
    /// </summary>
    abstract class Animals
    {
        /// <summary>
        /// каждое животное умеет ходить
        /// </summary>
        public abstract void Walk();
        /// <summary>
        /// Данный метод показывает какой звук издает животное
        /// </summary>
        public abstract void Speak();
        /// <summary>
        /// Каждое животное кушает, этот метод описывает что он кушает и сколько
        /// </summary>
        /// <returns>Сколько животное скушало</returns>
        public abstract double Eat();
    }
    /// <summary>
    /// Класс домашних животных, которые наследуются от класса Животных
    /// </summary>
    class Pets : Animals
    {
        public double weight;//вес животного 

        //переопределенные методы абстрактного класса
        /// <summary>
        /// метод, отвечающий за вид передвижения домашнего питомца
        /// в месте с тем, переопределяем методы из класса "Животные"
        /// </summary>
        public override void Walk()
        {
            //каждое домашне животное умеет передвигаться
            Console.WriteLine("Животное ходит");
        }
        /// <summary>
        /// домашнее животное издает звук
        /// </summary>
        public override void Speak()
        {
            //какой конкретно звук- мы не знаем, но в общем случае домашние животные издают звук
            Console.WriteLine("Домашнее животное издает звук");
        }
        /// <summary>
        /// домашнее животное что то кушат
        /// </summary>
        /// <returns></returns>
        public override double Eat() {
            //в общем случае, предлположим что домашнее животное может употребить до 250гр. корма
            weight += 0.25;
            //нужно оповестить что животное кушает
            Console.WriteLine("Домашнее животное кушает");
            //возвращаем вес животного
            return weight;
        }
        /// <summary>
        /// домашнее животное умеет пить, но сколько - в зависимости от вида домашнего питомца
        /// </summary>
        /// <returns></returns>
       
        //уникальный метод:
        public double Drink() {
            //в общем случае, предлположим что домашнее животное может употребить до 400мл. воды после употребления корма
            weight += 0.4;
            //нужно оповестить что животное уталило жажду
            Console.WriteLine("Домашнее животное кушает");
            //возвращаем вес животного
            return weight;
        }

    }

    class Cats : Pets 
    {
        string Name;//имя кота
        public double portion; //объем порции
        //свойство:
        /// <summary>
        /// Свойство, которое возвращает и записывает значение закрытого поля
        /// </summary>
        public string Name_cat
        {
            get { return Name; }
            set { Name = value; }
        }

        //Переопредеелнный метод из базового класса
        /// <summary>
        /// Метод,который описывает изменение веса при хотьбе по дому
        /// </summary>
        public override void Walk()
        {
            //т.к. кот ходит по дому, тогда он теряет, предположим 50 гр своего веса.
            weight -= 0.05;
            //сообщаем, что определенный кот охотится на мышку
            Console.WriteLine("Кот по кличке {0}, ходит по дому", Name_cat);
        }

        //замещенные методы:
        public new void Speak()
        {
            //сообщаем, что определенный котик умеют говорить мяяяу:) особенно в 5 утра:))
            Console.WriteLine("Кот по кличке {0} говорит: мяяяу", Name_cat);
        }
        /// <summary>
        /// Коты любят покушать, они должны кушать определенное количество корма за раз. Объем порции корма зависит от веса котика.
        /// </summary>
        /// <returns>порцию, сколько котик скушал</returns>
        public new double Eat()
        {
            //определяем по весу кота сколько ему нужно дать корма (на 1 кг - 15 грамм)
            portion = weight * 0.015;

            //изменям вес котика
            weight += portion;
            //возвращаем значение г корма, сколько съел кот
            return portion;
        }
        /// <summary>
        /// Коты после приема сухого корма должны пить определенное количество воды, которое расчитывается как отношение на 15гр корма приходится 30гр. воды.
        /// </summary>
        /// <returns>Возвращаем объем воды употребленной котиком в граммах</returns>
        public new double Drink()
        {
            //переменная для количества жидкости
            double liquid;
            //если котик захотел пить после приема сухого корма
            if (portion > 0)
            {
                //вычисляем сколько порций жидкости на 15 грамм корма нужно дать коту
                liquid = portion / 0.015;
                //на количество порций умножаем 30 грамм воды.
                liquid *= 0.030;
                //обнуляем порцию. потому что на эту порцию котик уже выпил водички
                portion = 0;
                
            }
            //когда котик захотел пить просто так
            else {
                //предположим, что он захотел попить 50 гр водички.
                liquid = 0.05;
            }
            //изменяем вес кота
            weight += liquid;
            //возвращаем измененное значение 
            return liquid;
        }

        //уникальные методы:
        /// <summary>
        /// Метод, коорый оповещает о том, что кот играется
        /// </summary>
        public void Playing()
        {
            //т.к. кот активно играется с мышкой, тогда он теряет, предположим 100 гр своего веса.
            weight -= 0.1;
            //сообщаем, что определенный кот играется с мышкой
            Console.WriteLine("Кот по кличке {0} играется с мышкой", Name_cat);
        }
        /// <summary>
        /// Метод,который описывает изменение веса при охоте на добычу
        /// </summary>
        public void Hunt()
        {
            //т.к. кот активно охотится, тогда он теряет, предположим 70 гр своего веса.
            weight -= 0.07;
            //сообщаем, что определенный кот охотится на мышку
            Console.WriteLine("Кот по кличке {0} охотится на мышку", Name_cat);
        }
    }
}
